/**
 * Returns kebabCase string. ie:
 * lastName -> last-name
 * WebkitAnimate -> -webkit-animate
 * @param value
 */
export declare function kebab(value: string): string;
/**
 * Reverses a kebabCase string. ie:
 * last-name -> lastName
 * -webkit-animate -> WebkitAnimate
 * @param value
 */
export declare function reverseKebab(value: string): string;
/**
 * Used to set attributes on the given element.
 *
 * @param element HTMLElement to set attribute on
 * @param propertyKey name of the attribute
 * @param value value of the attribute
 */
export declare function setAttribute(element: HTMLElement, propertyKey: string, value: any): void;
export declare function setProperties(element: HTMLElement, attributes: {
    [key: string]: string;
}): void;
export declare function updateProperties(element: HTMLElement, newProps: {
    [key: string]: string;
}, oldProps?: {
    [key: string]: string;
}): void;
export declare function isEventProp(name: string): boolean;
export declare function extractEventName(name: string): string;
export declare function setEventListener(element: HTMLElement, name: string, event: any): void;
export declare function debounce(func: Function, wait?: number, immediate?: boolean): () => void;
