import { debounce, reverseKebab } from './common';
import { createStyles } from './styles';
import { render } from './vdom';
export function CustomElement(name) {
    const CustomElement = (_a = class extends HTMLElement {
            /**
             *
             */
            constructor(...args) {
                super(...args);
                this.__rendering = false;
                this.__attached = false;
                if (!this.shadowRoot) {
                    this.attachShadow({ mode: 'open' });
                }
                // assign debounce function with arguments to render.
                this.__render = (immediate) => debounce(() => {
                    if (!this.__rendering) {
                        this.__rendering = true;
                        this.__dom = render(this.shadowRoot, this.template, this.__dom);
                        this.__rendering = false;
                    }
                }, 50, immediate);
            }
            static get is() {
                return name;
            }
            connectedCallback() {
                this.shadowRoot.appendChild(createStyles(this.styles));
                this.__render(true)();
                this.__attached = true;
            }
            attributeChangedCallback(attributeName, oldValue, newValue) {
                // if a property is set on the dom, sync it to the internal property
                if (newValue === oldValue) {
                    return;
                }
                this[reverseKebab(attributeName)] = newValue;
                if (this.__attached) {
                    // Re-render template whenever attributes change
                    this.__render()();
                }
            }
        },
        _a.observedAttributes = [],
        _a);
    return CustomElement;
    var _a;
}
//# sourceMappingURL=customElement.js.map